package hu.bme.mit.socialnetwork.resources.generator

import hu.bme.mit.socialnetwork.resources.GeneratorHelper
import org.eclipse.emf.ecore.resource.Resource
import socialnetwork.Community
import socialnetwork.Person

class HTMLReportGenerator {
	
	def generate(Resource res, GeneratorHelper helper) {
		for (e : res.allContents.toIterable.filter(typeof(Community))) {
			helper.createFile(e.name + ".html", e.compile)
		}
	}
	
	def clean(Resource res, GeneratorHelper helper) {
		for (e : res.allContents.toIterable.filter(typeof(Community))) {
			helper.cleanFile(e.name + ".html")
		}		
	}
	
	def compile(Community c) '''
	<html>
	  <head>
	    <title>Community «c.name»</title>	
	  </head>
	  <body>
	    <p>This is the generated webpage of the Community «c.name»</p>
	    <p>The following persons are the members of this community:
	      <ul>
	        «FOR p : c.members»
	        	«p.compile»
	        «ENDFOR»
	      </ul>
	    </p>
	  </body>
	</html>	
	'''
	
	def compile(Person p) '''
	    <li>«p.name», «p.sex»</li>
	'''
}