package hu.bme.mit.socialnetwork.resources;

import java.io.ByteArrayInputStream;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.IFolder;
import org.eclipse.core.resources.IProject;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.NullProgressMonitor;

public class GeneratorHelper {

	IProject project;
	IFolder outputFolder;
	
	public GeneratorHelper(IProject project) {
		super();
		this.project = project;
		outputFolder = project.getFolder(SocialNetworkProjectNature.OUTPUTDIR);
	}

	public void createFile(String filename, CharSequence contents) throws CoreException {
		IFile file = outputFolder.getFile(filename);
		String newContent = contents.toString();
		ByteArrayInputStream source = new ByteArrayInputStream(newContent.getBytes());
		
		if (file.exists()) {
			file.setContents(source, true, true, new NullProgressMonitor());
		} else {
			file.create(source, true, new NullProgressMonitor());
		}
		file.setDerived(true, new NullProgressMonitor());
	}
	
	public void cleanFile(String filename) throws CoreException {
		IFile file = outputFolder.getFile(filename);
		file.delete(true, new NullProgressMonitor());
	}
}
